// Brian Taylor Fractal Geometry

#include <nostub.h>
#include <graph.h>
#include <kbd.h>

int _ti89;

void c_curve(int x1, int y1, int x2, int y2, int level)
{
	int xm, ym;

	if (level == 0)
		DrawLine(x1, y1, x2, y2, A_NORMAL);
	else
	{
		xm = (x1 + x2 + y1 - y2) / 2;
		ym = (x2 + y1 + y2 - x1) / 2;
		c_curve(xm, ym, x1, y1, level - 1);
		c_curve(x1, y1, xm, ym, level - 1);
	}
}

int _main()
{
	int level = 0;
	int ch;
	LCD_BUFFER buffer;
	LCD_save (buffer);
		
	PortRestore();
	ch = 's';
	while (ch != 264)
	{
		ClearScreen();
		c_curve(98, 30, 98, 115, level);
		ch = ngetchx();
		if (ch == 264)
			break;
		if (ch == 265)
			level = 0;
		else
			level++;
	}
	
	LCD_restore (buffer);
	return 0;
}

